function Datepicker(datebox)
{
  this.datebox = datebox;
  this.window = window.open('about:blank', 'picker', 'WIDTH=175,HEIGHT=227,RESIZABLE=yes,SCROLLBARS=no,STATUS=0');
  var date = Date.parse(datebox.value);
  this.date = date ? new Date(date) : new Date();
  
  this.addmonth = Datepicker_addmonth;
  this.choose = Datepicker_choose;
  this.update = Datepicker_update;

  this.update();
}

function Datepicker_addmonth(months)
{
  this.date.setMonth(this.date.getMonth() + months);
}

function Datepicker_choose(year, month, date)
{
  this.datebox.value = '' + (month + 1) + '/' + date + '/' + year;
  this.window.close();
}

function Datepicker_update() // html based on msn calendar, calendaring is written with javascript date methods, not isapi
{
  d = this.window.document;
  
  var months = Array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
  var days = Array("Sunday","Monday","Tuesday","Wedensday","Thursday","Friday","Saturday");
  var thedate = this.date;

  d.open();
  d.write('<html>\n');
  d.write('<head><title>Chooser</title></head>\n');
  d.write('<BODY BGCOLOR="#FFFFFF" TEXT="#000000" LINK="#003399" VLINK="#003399" ALINK="#003399" TOPMARGIN="5" LEFTMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="5">\n');
  d.write('<TABLE CELLPADDING="0" CELLSPACING="0" WIDTH="175" BORDER="0">');
  d.write('<TR>\n');
  d.write('  <TD WIDTH="5" ROWSPAN="6"><IMG SRC="image/nada.gif" WIDTH="5" HEIGHT="5"></TD>\n');
  d.write('  <TD HEIGHT="19" BGCOLOR="#336699" NOWRAP ALIGN="center" COLSPAN="3"><A HREF="javascript:window.picker.addmonth(-1); void(window.picker.update());"><IMG SRC="image/arrow_left.gif" WIDTH="11" HEIGHT="8" BORDER="0"></A>&nbsp;&nbsp;<B><FONT STYLE="COLOR: #ffffff; FONT-FAMILY: arial,san-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold">');
  d.write(months[thedate.getMonth()] + ' ' + thedate.getFullYear()); //dynamicify
  d.write('</FONT></B>&nbsp;&nbsp;<A HREF="javascript:window.picker.addmonth(1); void(window.picker.update());"><IMG SRC="image/arrow_right.gif" WIDTH="11" HEIGHT="8" BORDER="0"></A></TD>\n');
  d.write('  <TD WIDTH="5" ROWSPAN="6"><IMG SRC="image/nada.gif" WIDTH="5" HEIGHT="5"></TD>\n');
  d.write('</TR>\n<TR>\n');
  d.write('  <TD WIDTH="1" BGCOLOR="#336699" ROWSPAN="4"><IMG SRC="image/nada.gif" WIDTH="1" HEIGHT="1"></TD>\n');
  d.write('  <TD HEIGHT="1" BGCOLOR="#999999"><IMG SRC="image/nada.gif" WIDTH="1" HEIGHT="1"></TD>\n');
  d.write('  <TD WIDTH="1" BGCOLOR="#336699" ROWSPAN="4"><IMG SRC="image/nada.gif" WIDTH="1" HEIGHT="1"></TD>\n');
  d.write('</TR>\n<TR BGCOLOR="#ffffff">\n');
  d.write('  <TD ALIGN="center" WIDTH="173">\n\n');
  d.write('<BASEFONT FACE="arial,sans-serif,helvetica" COLOR="#000000" STYLE="FONT-FAMILY: arial,sans-serif,helvetica; FONT-SIZE: 11px">\n');
  d.write('<TABLE BORDER="0" CELLPADDING="2" CELLSPACING="0" WIDTH="140">\n');
  d.write('<TR><TD COLSPAN="7"><IMG SRC="image/nada.gif" WIDTH="1" HEIGHT="1"></TD></TR>\n');
  d.write('<TR ALIGN="right" STYLE="FONT-FAMILY: arial,sans-serif,helvetica; FONT-SIZE: 11px"><TD WIDTH="20">Su</TD><TD WIDTH="20">Mo</TD><TD WIDTH="20">Tu</TD><TD WIDTH="20">We</TD><TD WIDTH="20">Th</TD><TD WIDTH="20">Fr</TD><TD WIDTH="20">Sa</TD></TR>\n');
  d.write('<TR><TD COLSPAN="7"><IMG SRC="image/nada.gif" WIDTH="1" HEIGHT="1"></TD></TR>\n');
  
  var today = new Date();
  var tyear = today.getFullYear();
  var tdate = today.getDate();
  var tmonth = today.getMonth();
  
  var oldmonth = thedate.getMonth();
  var thedate = new Date(thedate.getFullYear(), oldmonth, 1);
  thedate.setDate(thedate.getDate() - thedate.getDay());
  do
  {
    d.write('<TR ALIGN="right" STYLE="FONT-FAMILY: arial,sans-serif,helvetica; FONT-SIZE: 11px">\n');
    for(var i=0; i<7; ++i)
    {
      var year = thedate.getFullYear();
      var month = thedate.getMonth();
      var date = thedate.getDate();
      d.write('  <TD' + (date == tdate && month == tmonth && year == tyear ? ' BGCOLOR="#CCE6FF"' : '')+ '>&nbsp;<A HREF="javascript:void(window.picker.choose(' + year + ',' + month + ',' + date + '));">');
      if (month != oldmonth) d.write('<FONT COLOR="#999999">' + date + '</FONT>'); else d.write(date);
      d.write('</A></TD>\n');
      thedate.setDate(thedate.getDate() + 1);
    }
    d.write('</TR>\n');
  } while(thedate.getMonth() == oldmonth);

  d.write('</TABLE><BR>\n');
  d.write('</BASEFONT>\n\n');
  d.write('  </TD>\n');
  d.write('</TR>\n<TR BGCOLOR="#cccccc">\n');
  d.write('  <TD HEIGHT="1"><IMG SRC="image/nada.gif" WIDTH="1" HEIGHT="1"></TD>\n');
  d.write('</TR>\n<TR BGCOLOR="#ffffff">\n');
  d.write('  <TD HEIGHT="19" ALIGN="center" NOWRAP><IMG SRC="image/nada.gif" WIDTH="5" HEIGHT="5"><BR><FONT FACE="arial,sans-serif,helvetica" COLOR="#000000" size="-1" STYLE="COLOR: #000000; FONT-FAMILY: arial,sans-serif,helvetica; FONT-SIZE: 11px; TEXT-DECORATION: none">&nbsp;Today is:&nbsp;<BR>&nbsp;');
  d.write('<A HREF="javascript:void(window.picker.choose(' + tyear + ',' + tmonth + ',' + tdate + '));">' + days[today.getDay()] + ' ' + months[tmonth] + ' ' + tdate + ',' + tyear + '</A>');
  d.write('&nbsp;<BR><IMG SRC="image/nada.gif" WIDTH="5" HEIGHT="5"></FONT></TD>\n');
  d.write('</TR>\n<TR BGCOLOR="#336699">\n');
  d.write('  <TD HEIGHT="1" COLSPAN="3"><IMG SRC="image/nada.gif" WIDTH="1" HEIGHT="1"></TD>\n');
  d.write('</TR>\n</TABLE>\n</BODY>\n</HTML>');
  d.close();
  
  this.window.picker = this;
}
